#ifndef INCLUDE__Guile_hxx_
#define INCLUDE__Guile_hxx_

#include <libguile.h>

#include "Interpreter.hxx"

class GuileInterpreter : public Interpreter {
public:
	GuileInterpreter();

	int evaluate(const std::string& command,
	             std::ostream& stdout,
	             std::ostream& stderr,
	             std::string& result);

	int loadFile(const std::string& filename,
	             std::ostream& stdout,
	             std::ostream& stderr,
	             std::string& result);

	std::string fileExtension() const {return "scm";}
private:
	SCM guile_output_port;
	SCM guile_error_port;
};

#endif /* INCLUDE__Guile_hxx_ */
